public class TestDeleg {

	public static void main(String argv[]) {
		Point2D p  = new Point2DXY(5,5);
		Point2D p2 = new Point2DArray(5,5);
		Point2D p3 = new Point2DArray(15,15);
		Color a = new ColorInt(30,40,50,200);
		Color b = new Color4Int(30,40,50,200);
		Color d = new Color4Int(20,30,40,100);
		
		PointWithColor_1 pc1 = new PointWithColor_1(10,10,32,42,52,100);
		PointWithColor_2 pc2 = new PointWithColor_2((Point2DArray)p2,(ColorInt)a);
		PointWithColor_3 pc3 = new PointWithColor_3(p2,a);
		PointWithColor_3 pc4 = new PointWithColor_3(p,b);
		PointWithColor_3 pc5 = new PointWithColor_3(p3,b);
		PointWithColor_3 pc6 = new PointWithColor_3(p2,b);
		PointWithColor_4 pc7 = new PointWithColor_4(p2,b);
		PointWithColor_4 pc8 = new PointWithColor_4(p2,b);
		System.out.println(a);
		System.out.println(b);
		System.out.println(d);
		System.out.println(pc1);
		System.out.println(pc2);
		System.out.println(pc3);
		System.out.println(pc4);
		System.out.println(pc5);
		System.out.println(pc6);
		System.out.println(pc7);
		System.out.println("\np2.equals(pc3) : " + p2.equals(pc3));
		System.out.println("pc3.equals(p2) : " + pc3.equals(p2) + "\n");
		System.out.println("a.equals(pc3) : " + a.equals(pc3));
		System.out.println("pc3.equals(a) : " + pc3.equals(a) + "\n");
		System.out.println("a.equals(pc4) : " + a.equals(pc4));
		System.out.println("pc4.equals(a) : " + pc4.equals(a) + "\n");
		System.out.println("pc6.equals(pc3) : " + pc6.equals(pc3));
		System.out.println("pc3.equals(pc6) : " + pc3.equals(pc6) + "\n");
		System.out.println("pc5.equals(pc4) : " + pc5.equals(pc4));
		System.out.println("pc4.equals(pc5) : " + pc4.equals(pc5) + "\n");
		System.out.println("((Color)pc5).equals(pc4) : " + ((Color)pc5).equals(pc4) + "\n");
		System.out.println("pc4.equals((Color)pc5) : " + pc4.equals((Color)pc5) + "\n");
		System.out.println("pc6.equals(pc7) : " + pc6.equals(pc7));
		System.out.println("pc7.equals(pc6) : " + pc7.equals(pc6) + "\n");
		System.out.println("pc5.equals(pc7) : " + pc5.equals(pc7));
		System.out.println("pc7.equals(pc5) : " + pc7.equals(pc5) + "\n");
		System.out.println("b.equals(pc7) : " + b.equals(pc7));
		System.out.println("pc7.equals(b) : " + pc7.equals(b));
		System.out.println("pc3.equals(new Integer(5)) : " + pc3.equals(new Integer(3)));
		System.out.println("pc7.equals(new Integer(5)) : " + pc7.equals(new Integer(3)));
		System.out.println("pc7.equals(pc8) : " + pc7.equals(pc8));
	}
}

// (30,40,50,200)
// (30,40,50,200)
// (20,30,40,100)
// point (10.0,10.0) with color (32,42,52,100)
// point (5.0,5.0) with color (30,40,50,200)
// point (5.0,5.0) with color (30,40,50,200)
// point (5.0,5.0) with color (30,40,50,200)
// point (15.0,15.0) with color (30,40,50,200)
// point (5.0,5.0) with color (30,40,50,200)
// (5.0,5.0) with color (30,40,50,200)
// equals Point2DAbstract sur (5.0,5.0)
// p2.equals(pc3) : true
// equals Point2DAbstract sur (5.0,5.0)
// pc3.equals(p2) : true
// equals ColorAbstract sur (30,40,50,200)
// a.equals(pc3) : true
// equals ColorAbstract sur (30,40,50,200)
// pc3.equals(a) : true
// equals ColorAbstract sur (30,40,50,200)
// a.equals(pc4) : true
// equals ColorAbstract sur (30,40,50,200)
// pc4.equals(a) : true
// equals ColorAbstract sur (30,40,50,200)
// equals Point2DAbstract sur (5.0,5.0)
// pc6.equals(pc3) : true
// equals ColorAbstract sur (30,40,50,200)
// equals Point2DAbstract sur (5.0,5.0)
// pc3.equals(pc6) : true
// equals ColorAbstract sur (30,40,50,200)
// equals Point2DAbstract sur (15.0,15.0)
// pc5.equals(pc4) : false
// equals ColorAbstract sur (30,40,50,200)
// equals Point2DAbstract sur (5.0,5.0)
// pc4.equals(pc5) : false
// equals ColorAbstract sur (30,40,50,200)
// equals Point2DAbstract sur (15.0,15.0)
// ((Color)pc5).equals(pc4) : false
// equals ColorAbstract sur (30,40,50,200)
// equals Point2DAbstract sur (5.0,5.0)
// pc4.equals((Color)pc5) : false
// equals ColorAbstract sur (30,40,50,200)
// equals Point2DAbstract sur (5.0,5.0)
// pc6.equals(pc7) : true
// equals Point2DAbstract sur (5.0,5.0) with color (30,40,50,200)
// pc7.equals(pc6) : true
// equals ColorAbstract sur (30,40,50,200)
// equals Point2DAbstract sur (15.0,15.0)
// pc5.equals(pc7) : false
// equals Point2DAbstract sur (5.0,5.0) with color (30,40,50,200)
// pc7.equals(pc5) : false
